%======================================================================
%     Test function for the MEX file dggev generated from the LAPACKE package.
%     (See: http://www.netlib.org/lapack/explore-html/de/d27/lapacke__dggev_8c.html for details)
%     Copyright (C) 2009-2015 Peter Rakyta, Ph.D.
%
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see http://www.gnu.org/licenses/.
function dggev_test()

	% test matrices
	dim = 40;
	A = rand(dim);
	B = rand(dim);


	filename = mfilename('fullpath');
	[directory, fncname] = fileparts( filename );
    fncname = fncname(1:end-length('_test'));
    filename = fullfile( directory, [fncname, '.', mexext] );


  	% Call the newly compiled function.
	try
  		[ALPHAR, ALPHAI,BETA,lvec,rvec] = feval(fncname, A, B);
	catch err
		warning([fncname, ' failed to run. Deleting the compiled MEX file.']);
		delete(filename);
		disp( err.identifier )
		disp( err.message )
		pause(3)
		return
	end

	%test the calculated eigenvalues
	eig_values = eig(A,B);

	error_num = norm( abs(sort(eig_values, 'ascend')) - abs(sort((ALPHAR+1i*ALPHAI)./BETA, 'ascend')) );
	if error_num < 1e-10
		display('***************************************************************************')
		disp(['Test of ', fncname, ' passed.'])
	else
		warning(['Test of ', fncname, ' failed with an error ', num2str(error_num), '. Deleting the compiled MEX file.'])
		%delete(filename);
		return
	end


end
