%%    Eotvos Quantum Transport Utilities - Surface_Green_function
%    Copyright (C) 2009-2016 Peter Rakyta, Ph.D.
%
%    This program is free software: you can redistribute it and/or modify
%    it under the terms of the GNU General Public License as published by
%    the Free Software Foundation, either version 3 of the License, or
%    (at your option) any later version.
%
%    This program is distributed in the hope that it will be useful,
%    but WITHOUT ANY WARRANTY; without even the implied warranty of
%    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%    GNU General Public License for more details.
%
%    You should have received a copy of the GNU General Public License
%    along with this program.  If not, see http://www.gnu.org/licenses/.
%
%> @addtogroup basic Basic Functionalities
%> @{
%> @file Surface_Green_function.m
%> @brief A class to calculate the Green functions and self energies of a translational invariant lead. This class was replaced by class Lead and it is kept only for backward compatibility reasons.
%> @} 
%> @brief A class to calculate the Green functions and self energies of a translational invariant lead. This class was replaced by class Lead and it is kept only for backward compatibility reasons.
%> The notations and the structure of the Hamiltonian is defined accroding to the following image:
%> @image html Lead_Hamiltonian.jpg
%> @image latex Lead_Hamiltonian.jpg
%>  
%%
classdef Surface_Green_function < Lead
    
    

methods ( Access = public )
%% constructorof the class
%> @brief Constructor of the class.
%> @param Opt An instance of the structure Opt.
%> @param param An instance of structure param.
%> @param varargin Cell array of optional parameters to #Lead.Lead.
%> @return An instance of the class
    function obj = Surface_Green_function(Opt, param, varargin)    
        obj = obj@Lead( Opt, param, varargin{:} ); 
        
        if strcmpi(class(obj), 'Surface_Green_function')
            obj.Initialize();
        end
    end
    
    
end


%------------------------------------------------------------------
end % Global End
